# db-claims

- [Databases Supporting SI](https://dbdb.io/browse?isolation-levels=snapshot-isolation)
  - [x] [YugabyteDB](https://dbdb.io/db/yugabytedb)
  - [Apache Tephra](http://tephra.incubator.apache.org/) (as Apache HBase)
  - [Apache Phoenix Omid](http://omid.incubator.apache.org/basic-concepts.html)
  - [CouchDB](https://dbdb.io/db/couchdb) (待定)
    - [consistency](https://docs.couchdb.org/en/stable/intro/consistency.html#no-locking)
    > A read request will always see the most recent snapshot of your database at the time of the beginning of the request.
  - [Berkeley DB](https://dbdb.io/db/berkeley-db), [Docs on SI](https://docs.oracle.com/cd/E17076_03/html/programmer_reference/transapp_read.html#snapshot_isolation)
  - [Memgraph](https://dbdb.io/db/memgraph), [Docs on SI](https://memgraph.com/docs/memgraph/next/reference-guide/isolation-levels)
  - [AllegroGraph](https://dbdb.io/db/allegrograph), [Docs on SI](https://franz.com/agraph/support/documentation/current/agraph-introduction.html#Consistency)
  - [LevelDB by Google](https://dbdb.io/db/leveldb) (待定; 否定 by 刘思)
  - [RocksDB by Facebook](https://dbdb.io/db/rocksdb) (待定)
  - [Apache Hive](https://dbdb.io/db/hive)
  - [WiredTiger](https://dbdb.io/db/wiredtiger)
  - MongoDB
  - Google's Percolator
  - [Hypertable](https://dbdb.io/db/hypertable), [Docs on SI](https://www.hypertable.com/documentation/architecture)
  - [NuoDB](https://dbdb.io/db/nuodb)
  - [Snowflake](https://dbdb.io/db/snowflake) (**inconsistency between paper and docs**)
  - [Microsoft Azure SQL Database](https://dbdb.io/db/azure-sql-database)
  - [Microsoft SQL Server](https://dbdb.io/db/sql-server)
  - [Oracle]()
  - [ActivePivot](https://dbdb.io/db/activepivot)
- [Databases Supporting SER](https://dbdb.io/browse?isolation-levels=serializable)
  - [Cloud Spanner](https://dbdb.io/db/cloud-spanner)
  - [Delta Lake](https://dbdb.io/db/delta-lake)
  - [FoundationDB]()
  - [Microsoft Azure SQL Database](https://dbdb.io/db/azure-sql-database)
  - [Microsoft SQL Server](https://dbdb.io/db/sql-server)
- Other Databases
  - [Oceanbase](https://open.oceanbase.com/docs/observer-cn/V3.1.1/10000000000013335): ANSI RC, RR
- [3TS-Coo](https://axingguchen.github.io/3TS/)
  > 3TS-Coo is a consistency check tool for transactional databases. Coo checks the consistency of databases in accurate (all types of anomalies), user-friendly (SQL-based test), and cost-effective (one-time checking in a few minutes) ways.

- Galera
  - [Support for Transaction Isolation Levels](https://galeracluster.com/library/training/tutorials/supporting-transaction-isolation-levels.htm)
- Greenplum
  - [Transaction Isolation Levels in Greenplum database](http://www.greenplumdba.com/transaction-isolation-level)
  > The SQL standard defines four transaction isolation levels. In Greenplum Database, you can request any of the four standard transaction isolation levels. But internally, there are only two distinct isolation levels — read committed and serializable.
  - [Transaction Isolation Levels](https://gpdb.docs.pivotal.io/6-0/admin_guide/dml.html#:~:text=The%20default%20transaction%20isolation%20level%20in%20Greenplum%20Database,the%20SET%20TRANSACTION%20command%20after%20the%20transaction%20starts.)
  > Greenplum Database accepts the standard SQL transaction levels as follows: READ UNCOMMITTED and READ COMMITTED behave like the standard READ COMMITTED; REPEATABLE READ and SERIALIZABLE behave like REPEATABLE READ.
  > If you specify SERIALIZABLE Greenplum Database falls back to REPEATABLE READ. REPEATABLE READ transactions prevent dirty reads, non-repeatable reads, and phantom reads without expensive locking, ***but Greenplum Database does not detect all serializability interactions that can occur during concurrent transaction execution***. Concurrent transactions should be examined to identify interactions that are not prevented by disallowing concurrent updates of the same data. You can prevent these interactions by using explicit table locks or by requiring the conflicting transactions to update a dummy row introduced to represent the conflict.
- [Snowflake](https://dbdb.io/db/snowflake#:~:text=According%20to%20their%20paper%20and%20talk%2C%20Snowflake%20supports,is%20the%20only%20Isolation%20level%20that%20is%20supported.)
  > According to their paper and talk, Snowflake supports Snapshot Isolation. However, according to their documentation, it is said that Read Committed is the only Isolation level that is supported.